--[[function drawplayer()

	screen_width = 600
	screen_height = 360

	playerx = screen_width/2 + 200
	playery = screen_height/2


	tilesheet = love.graphics.newImage( "Alloy_curses_12x12.png" )

	local tileW, tileH = 12,12
	local tilesetW, tilesetH = tilesheet:getWidth(), tilesheet:getHeight()

	playerquad = love.graphics.newQuad(0,  48, tileW, tileH, tilesetW, tilesetH)

 	love.graphics.draw(tilesheet, playerquad, playerx, playery)

end]]


Player = {}
Player.__index = Player

function Player.create(x,y)
   	local hue = {}             -- our new object
  	setmetatable(hue,Player)  -- make Account handle lookup
   	hue.x = x      -- initialize our object
   	hue.y = y
	return hue
end

function Player:draw(x,y)

	tilesheet = love.graphics.newImage( "Alloy_curses_12x12.png" )

	local tileW, tileH = 12,12
	local tilesetW, tilesetH = tilesheet:getWidth(), tilesheet:getHeight()

	playerquad = love.graphics.newQuad(0,  48, tileW, tileH, tilesetW, tilesetH)

	love.graphics.draw(tilesheet, playerquad, self.x, self.y)

	--return self.x,self.y

end

function Player:coordinate(x,y)

	return self.x,self.y
end


function Player:move(dx,dy)
   	self.x = self.x + (dx*12)
	self.y = self.y + (dy*12)
end

--[[ create and use an Account
acc = Account.create(1000)
acc:withdraw(100)]]
