local tileString = [[
..................................................
..................................................
.....[---------].......[---]......................
.....|         |.......|   |......................
.....|         =========   |......................
.....|         |.......|   |......................
.....;---- ----:.......;-=-:......................
.........|=|.............=........................
.........|=|.............=........................
.........|=|........======........................
.........|=|........=.............................
.........|=|........=.............................
....[-----=---------=------]......................
....|                      |......................
....|                      |......................
....|                      |......................
....;----------------------:......................
..................................................
..................................................
]]

local quadInfo = {
  { '.', 0, 0 }, -- floor
  { ' ', 160, 96 }, --5,3
  { '[', 32, 32 }, -- wall left top corner
  { ']', 544, 32 }, -- wall right top corner
  { '|', 32, 64 }, -- wall left and right
  { '-', 96,32 }, -- wall top and bottom
  { ':', 576,352 }, --corner right side bottom 18/11
  { ';', 32,224 }, -- corner left side bottom
  { '=', 416,256}, --floortilebetween rooms
}

newMap(32,32,'tileset.png',tileString,quadInfo)
