require 'names'
require 'map'
output = {}
map = {}
map.time = 30

function output.mainmenu()

	menufont = love.graphics.newFont("visitor1.ttf",50)
	introfont = love.graphics.newFont("yoster.ttf",90)

	love.graphics.setFont(introfont)
	love.graphics.setColor(0,0,0)
	love.graphics.printf("thisshitsgoodd0e",0,height/10,800,"center") 
	love.graphics.setFont(menufont)
	love.graphics.printf("Play enter", 0,220,width,"center")
	love.graphics.printf("Story s", 0,320,width,"center")
	love.graphics.printf("Credits c", 0,420,width,"center")
	love.graphics.printf("Quit q", 0,520,width,"center")	

end


function output.player()

	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill",(playertilex-1)*12+200,(playertiley-1)*12,12,12)
	love.graphics.setColor(a,b,c)
	love.graphics.draw(tilesheet, playerquad, 12*(playertilex-1)+200, 12*(playertiley-1))

end

function output.timer() --for checking

	output.addMessage("The time is: "..map.time)

end

function output.gamefade(dt)

	if map.time > 0 then
		map.time = map.time - dt
	end

	if map.time < 0 then
		playertest.alive = false
	end

end

function output.introgame()

	output.addMessage("Depart with haste you don't have much time!")

	--output.addMessage("Here on the floor lies a katana. Pick it up with ,")

	output.addMessage("What is that green fluid dripping out of it?")
	output.addMessage("As you look down you see a bite in your arm. It's bleeding heavily.")
	output.addMessage("You are trapped in a dungeon and the only way out is going deeper into it")
	output.addMessage("Hey there "..playertest.name)
end

function output.stats()

	--left bar

	namefont = love.graphics.newFont("pcpaintbig.ttf",8)

	love.graphics.setColor(255,255,255)

	love.graphics.setFont(namefont)

	love.graphics.printf(playertest.name,0,50,200,"center")

	--love.graphics.setColor(0,255,0)

	love.graphics.printf(string.upper("Health Points:".." "..playertest.hp),0,100,200,"center")

	love.graphics.setColor(255,255,255)

	--MAYBE HP BAR!!!!!!!!!

	love.graphics.setColor(255,255,255)

	love.graphics.printf(string.upper("Experience: "..playertest.experience),0,150,200,"center")

	love.graphics.printf(string.upper("Dungeon Level: "..playertest.dungeonlevel),0,200,200,"center")

	love.graphics.printf(string.upper("Walked Tiles: "..playertest.tilecount),0,250,200,"center")

	love.graphics.printf(string.upper("Coins: "..playertest.money),0,300,200,"center")

	--love.graphics.print(string.upper("lololol"),50,300)
end

function output.messages()

		for i,v in ipairs(messageTable) do
		-- 12 is the assumed font size, we want 0 displacement for the first element, and since lua has 1-based
		-- indexing, we're subtracting one from the i index; the pxOffset multiplication is the sliding	
		--love.graphics.printf(v.message,0,(i-1)*12*v.pxOffset,screenWidth,"center")
		--love.graphics.printf(v.message,0,(i-1)*12+12*v.pxOffset,screenWidth,"center")
		--love.graphics.setColor(255,255,255)
			love.graphics.printf(string.upper(v.message),200,(i-1)*12-12*v.pxOffset+410,600,"center")
		end

		output.updateMessages()
		
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill",210,550,600,50)

end

function output.addMessage(message)

	-- push all messages back by one

	for i=#messageTable,1,-1 do
		messageTable[i].pxOffset = messageTable[i].pxOffset + 1
		messageTable[i+1] = messageTable[i]
	end

	-- add the new message to the front
	--
	--if addmessagetest == true then

	messageTable[1] = {
		['message'] = message,
		['pxOffset'] = 0
	}

	--end

	--addmessagetest = false

	-- so the code can know how many entries have been added...

	messageTable.delta = messageTable.delta + 1

	-- needed so the update fx can "animate" the x and y positions, to slide the message down

	messageTable.triggered = true

end

function output.updateMessages()

	local check = 0

	if messageTable.triggered then

		for i,v in ipairs(messageTable) do
			if v.pxOffset > 0 then
				v.pxOffset = 0 --v.pxOffset - messageTable.slideSpeed * dt 
			else
				check = check + 1
			end
		end

		-- if the sliding has finished for every element, then set trigger to false

		if check == #messageTable then
			
			messageTable.triggered = false

		end

	end

end

function output.gameover()


	--messageTable = nil

	output.addMessage("Try harder next time!")

	output.addMessage("You just died at Dungeon level: "..playertest.dungeonlevel)

	output.addMessage("Press q to return to the main menu")	

	--still buggy have to change

end

--[[function output.playergameover(dt)
	
	love.graphics.setColor(a,b,c)
	--rotate 90 to left and get bigger
	--angle in degrees = angle in radians * 180/PI
	s = 0
	x = 1
	y = 1
	if math.rad(s) < math.pi/2 then
		s = s + dt
	end

	if x > 4 then
		x = x + dt
	end

	--[[if y > 4 then
		y = y + dt
	end

	love.graphics.draw(tilesheet, playerquad, 12*(playertilex-1)+200, 12*(playertiley-1),0,x,x)--math.rad(s),x,y)	

end]]


function output.mainmenumouse()

	local x, y = love.mouse.getPosition()

	if y > 220 and y < 270 then
		love.graphics.setColor(0,0,0)
		love.graphics.printf("Play enter", 255,220,width)

		if love.mouse.isDown('l')  then
			state = 'game'
		end
	

	elseif y > 320 and y < 350 then 

		love.graphics.setColor(0,0,0)
		love.graphics.printf("Story s", 300,320,width)

		if love.mouse.isDown('l')  then
			state = 'story'
		end

	elseif y > 410 and y < 470 then 

		love.graphics.setColor(0,0,0)
		love.graphics.printf("Credits c", 280,420,width)

		if love.mouse.isDown('l') then
			state = 'story'
		end

	elseif y > 520  and y < 560 then

		love.graphics.setColor(0,0,0)
		love.graphics.printf("Quit q", 325,520,width)

		if love.mouse.isDown('l') then
			love.event.quit()
		end

	
	end



end

function output.intro()

	love.graphics.setColor(223,243,199)
	love.graphics.rectangle("fill",0,0,width,height)
	love.graphics.setColor(255,255,255)
	love.graphics.draw(moon.img,moon.x,moon.y)
	--[[love.graphics.draw(cloud.cloud1.image, cloud.cloud1.x-300, cloud.cloud1.y)
	love.graphics.draw(cloud.cloud2.image, cloud.cloud2.x-300, cloud.cloud2.y)
	love.graphics.draw(cloud.cloud3.image, cloud.cloud3.x-225, cloud.cloud3.y)
	love.graphics.draw(cloud.cloud4.image, cloud.cloud4.x-225, cloud.cloud4.y)]]

	math.randomseed( os.time() )
	--math.random(); math.random(); math.random()

    	for i=1,#cloud do
		scale = 1 - love.math.random(0.1,0.3)*(i-1) --DOENST WORK ATM try out later
		love.graphics.draw(cloud[i].image,cloud[i].x- cloud[i].width, cloud[i].y,0,scale,scale )
   	end

end

--local src

--[[function output.selectsong()

	-- Initialize the pseudo random number generator
	math.randomseed( os.time() )
	math.random(); math.random(); math.random()
	-- done. :-)
	music = {love.audio.newSource("soundtrack.mp3"),love.audio.newSource("soundtrack2.mp3")}

	song = music[math.random(#music)]

	return song

end]]

function output.sound()

	-- Initialize the pseudo random number generator
	math.randomseed( os.time() )
	math.random(); math.random(); math.random()
	-- done. :-)

	if not music or music:isStopped() then
        	love.audio.stop()
		love.audio.setVolume(0.4)
		--src = love.audio.newSource("soundtrack.mp3")

		--local music = {}
		music = {love.audio.newSource("soundtrack.mp3"),love.audio.newSource("soundtrack2.mp3")}

		music = music[math.random(#music)]

		music:play()
    	end

end

--[[function output.sound(song)

	if song:isStopped() then
        	love.audio.stop()
		love.audio.setVolume(0.4)
		song:play()
	end

end]]

function output.credits()

	menufont = love.graphics.newFont("visitor1.ttf",40)
	love.graphics.setFont(menufont)
	love.graphics.setColor(223,243,199)
	love.graphics.rectangle("fill",0,0,width,height)
	love.graphics.setColor(0,0,0)
	if creditstext.y > height then
		state = "menu"
	end
	text = [[
	Map Algorithm by RogueBasin
	Tile Pack DAWNLIKE 16x16 by Platin
	Alexander Luyten
	Copyright 2013-2015
	Titlesong: Silent Park by Yasushi Yoshida
	Gymnasium Liestal]]
	love.graphics.printf(text,0,creditstext.y,width,"center")
end

function output.credits_movement(dt)

	creditstext.y = creditstext.y + (creditstext.speed * dt)

end

function output.story()
	
	menufont = love.graphics.newFont("visitor1.ttf",40)
	love.graphics.setFont(menufont)
	love.graphics.setColor(223,243,199)
	love.graphics.rectangle("fill",0,0,width,height)
	love.graphics.setColor(0,0,0)
	if creditstext.y > height then
		state = "menu"
	end
	text = [[Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua.]]
	love.graphics.printf(text,0,creditstext.y,width,"center")

end


function output.intro_movement(dt)

		--MOON MOVEMENT

	if moon.x > width then
		moon.x = 0 - moon.width
	end

	moon.y = moon.y - moon.speed.y * dt--math.sin(dt)
	moon.x = moon.x + (moon.speed.x * dt)

	--[[if moon.x < ((width/2) - (moon.width/2)) then
		moon.x = moon.x + (moon.speed.x * dt)
		moon.y = moon.y - (moon.speed.y * dt)
	elseif moon.x > ((width/2) - (moon.width/2)) then
		moon.x = moon.x + (moon.speed.x * dt)
		moon.y = moon.y + (moon.speed.y * dt)
	end]]

	--CLOUD MOVEMENT

--[[	cloud.cloud1.x = cloud.cloud1.x + cloud.cloud1.speed*dt 
	if cloud.cloud1.x > width + cloud.cloud1.width then --CHECK AND EDIT
		cloud.cloud1.x = 0
	end

	cloud.cloud2.x = cloud.cloud2.x + cloud.cloud2.speed*dt
	if cloud.cloud2.x > 1100 then --CHANGE
		cloud.cloud2.x = 0
	end

	cloud.cloud3.x = cloud.cloud3.x + cloud.cloud3.speed*dt
	if cloud.cloud3.x > 1100 then --CHANGE
		cloud.cloud3.x = 0
	end

	cloud.cloud4.x = cloud.cloud4.x + cloud.cloud4.speed*dt
	if cloud.cloud4.x > 1100 then --CHANGE
		cloud.cloud4.x = 0
	end]]

	for i=1,#cloud do
		cloud[i].x = cloud[i].x + cloud[i].speed*dt 
			if cloud[i].x > width + cloud[i].width then --CHECK AND EDIT
				cloud[i].x = 0
			end
	end


end

function output.game()

 	drawMap()

	--additems()
    	--love.graphics.draw(player.image,player.grid_x,player.grid_y)
    	--love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)

    	function math.clamp(x, min, max)
  		return x < min and min or (x > max and max or x)
    	end

	love.graphics.setColor(223,243,199)
	love.graphics.rectangle("line",0,0,200,600)

	love.graphics.rectangle("line",200,360,800,600)

	love.graphics.rectangle("line",200,0,800,600)

	love.graphics.rectangle("line",0,360,200,600)

	--width, height = love.graphics.getDimensions( )

	--love.graphics.print(width..height,300,300)
	
	-- MEANS THAT THE GAME SCREEN IS FROM 250,0 -> 800,350


end

function output.enemies()
	--[[local tileW, tileH = 12,12
  	local tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight()

	Quads = {}
	for _,info in ipairs(quadInfo) do
  		-- info[1] = character, info[2]= x, info[3] = y
  		Quads[info[1] ] = love.graphics.newQuad(info[2], info[3], TileW, TileH, tilesetW, tilesetH)
	end]]
	
	local tileW, tileH = 12,12
	local tilesetW, tilesetH = tilesheet:getWidth(), tilesheet:getHeight()
	enemyquad = love.graphics.newQuad(12,  0, tileW, tileH, tilesetW, tilesetH)
	bearquad = love.graphics.newQuad(24,  72, tileW, tileH, tilesetW, tilesetH)
	catquad = love.graphics.newQuad(36,  72, tileW, tileH, tilesetW, tilesetH)
	dogquad = love.graphics.newQuad(48,72,tileW,tileH,tilesetW,tilesetH)


	--tileW = tileWidth
  	--tileH = tileHeight



	for i, v in ipairs(enemies) do

		local x,y = (v.x-1)*tileW+200, (v.y-1)*tileH+0
		
		love.graphics.setColor(0,0,0)

		love.graphics.rectangle("fill",x,y,12,12)
		
		love.graphics.setColor(255,255,255,t)

		
		if v.name == "cat" then
			love.graphics.draw(tilesheet,catquad,x,y)
		elseif v.name == "dog" then
			love.graphics.draw(tilesheet,dogquad,x,y)
		elseif v.name == "bear" then
			love.graphics.setColor(255,33,92)
			love.graphics.draw(tilesheet,bearquad,x,y)
			love.graphics.setColor(255,255,255)
		end


		--love.graphics.draw(tilesheet,enemyquad,x,y) -- Then draw them.

      		--love.graphics.drawq(tilesheet, Quads[char], v.x, v.y)

			
		
	end

end

